
!RBSequenceNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 15:55'!
accept: aProgramNodeVisitor 
	^aProgramNodeVisitor visitSequenceNode: self! !

!RBLiteralValueNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 16:34'!
accept: aProgramNodeVisitor 
	^aProgramNodeVisitor visitLiteralNode: self! !

!RBParser methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 8/23/2011 16:12'!
selfNodeClass
	^ RBSelfNode! !

!RBParser methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 8/23/2011 16:12'!
superNodeClass
	^ RBSuperNode! !

!RBParser methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 8/30/2011 17:03'!
thisContextNodeClass
	^ RBThisContextNode! !

!RBArrayNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 16:32'!
accept: aProgramNodeVisitor
	^ aProgramNodeVisitor visitArrayNode: self! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 16:12'!
accept: visitor on: receiver message: aMessage
	self isPrimitive ifTrue: [ 
			^ visitor 
				invokePrimitiveMethod: self 
				on: receiver 
				message: aMessage ].
			
	self isReflective ifTrue: [ 
		^ visitor 
			invokeReflectiveMethod: self
			on: receiver 
			message: aMessage].
		
	^ visitor 
		invokeMethod: self 
		on: receiver 
		message: aMessage! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/9/2011 13:59'!
ast
	^ ASTCache at: self! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 14:14'!
code
	^ self ast! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 15:44'!
hasPragmaNamed: aSymbol
	^ (self pragmas at: aSymbol) isNil not! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 11:08'!
isPrimitive
	^ self primitive ~= 0! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 15:44'!
isReflective
	^ (self hasPragmaNamed: #reflective:)! !

!RBProgramNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 15:52'!
accept: aProgramNodeVisitor 
	self subclassResponsibility! !

!RBCascadeNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 16:33'!
accept: aProgramNodeVisitor 
	^aProgramNodeVisitor visitCascadeNode: self! !

!RBMessageNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 16:34'!
accept: aProgramNodeVisitor 
	^aProgramNodeVisitor visitMessageNode: self! !

!RBLiteralArrayNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 16:34'!
accept: aProgramNodeVisitor 
	^aProgramNodeVisitor visitLiteralArrayNode: self! !

!RBPragmaNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 15:53'!
accept: aProgramNodeVisitor 
	^ aProgramNodeVisitor visitPragmaNode: self! !

!RBReturnNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 15:54'!
accept: aProgramNodeVisitor 
	^aProgramNodeVisitor visitReturnNode: self! !

!RBAssignmentNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 16:33'!
accept: aProgramNodeVisitor 
	^aProgramNodeVisitor visitAssignmentNode: self! !

!RBMethodNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 15:53'!
accept: aProgramNodeVisitor 
	^aProgramNodeVisitor visitMethodNode: self! !

!RBMethodNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 15:47'!
hasPragmaNamed: aSymbol	
	^ self pragmas anySatisfy: [ :pragma| pragma selector = aSymbol]! !

!RBMethodNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 16:42'!
statements
	^ self body statements! !

!RBMethodNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 16:41'!
temporaries
	^ self body temporaries! !

!RBVariableNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 16:35'!
accept: aProgramNodeVisitor 
	^aProgramNodeVisitor visitVariableNode: self! !

!ContextPart methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/12/2011 14:33'!
returnContext
	^ self methodReturnContext! !

!RBBlockNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 16:33'!
accept: aProgramNodeVisitor 
	^aProgramNodeVisitor visitBlockNode: self! !

!RBBlockNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 16:43'!
statements
	^ self body statements! !

!RBBlockNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 17:18'!
temporaries
	^ self body temporaries! !
